## libdiscid 0.5.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
set(CMAKE_LEGACY_CYGWIN_WIN32 0)

PROJECT(libdiscid C)

# VERSION NUMBERING:
# see http://semver.org, we use that schmea starting with 0.x.x already though
# short:
# MAJOR is increased when backwards incompatible changes are made to the API
# MINOR is increased when features are added to the API
# PATCH is increase for all other releases
SET(libdiscid_MAJOR 0)
SET(libdiscid_MINOR 5)
SET(libdiscid_PATCH 1)


SET(libdiscid_VERSION ${libdiscid_MAJOR}.${libdiscid_MINOR}.${libdiscid_PATCH})
SET(libdiscid_SOVERSION ${libdiscid_MAJOR})
# version for windows resource file
SET(libdiscid_VERSION_RC ${libdiscid_MAJOR},${libdiscid_MINOR},${libdiscid_PATCH},0)
IF(libdiscid_PATCH LESS 10)
    SET(libdiscid_VERSION_NUM ${libdiscid_MINOR}0${libdiscid_PATCH})
ELSE()
    SET(libdiscid_VERSION_NUM ${libdiscid_MINOR}${libdiscid_PATCH})
ENDIF()

# currently the sole purpose of the project is the library,
# so we use that version
SET(PROJECT_VERSION ${libdiscid_VERSION})


SET(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
SET(EXEC_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX} CACHE PATH "Installation prefix for executables and object code libraries" FORCE)
SET(BIN_INSTALL_DIR ${EXEC_INSTALL_PREFIX}/bin CACHE PATH "Installation prefix for user executables" FORCE)
SET(LIB_INSTALL_DIR ${EXEC_INSTALL_PREFIX}/lib${LIB_SUFFIX} CACHE PATH  "Installation prefix for object code libraries" FORCE)
SET(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include CACHE PATH "Installation prefix for C header files" FORCE)

# compatibility with automake
SET(PACKAGE ${PROJECT_NAME})
SET(VERSION ${PROJECT_VERSION})
SET(PACKAGE_STRING "${PACKAGE} ${VERSION}")
SET(prefix ${CMAKE_INSTALL_PREFIX})
SET(exec_prefix ${EXEC_INSTALL_PREFIX})
SET(includedir ${INCLUDE_INSTALL_DIR})
SET(libdir ${LIB_INSTALL_DIR})

CONFIGURE_FILE(libdiscid.pc.in libdiscid.pc)
CONFIGURE_FILE(versioninfo.rc.in versioninfo.rc)
CONFIGURE_FILE(Doxyfile.in Doxyfile)
CONFIGURE_FILE(include/discid/discid.h.in include/discid/discid.h)

# normalizing operating systems
IF(CMAKE_SYSTEM_NAME MATCHES "Linux")
    SET(libdiscid_OS "linux")
ELSEIF(CMAKE_SYSTEM_NAME MATCHES "Darwin")
    SET(libdiscid_OS "darwin")
ELSEIF(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    SET(libdiscid_OS "freebsd")
ELSEIF(CMAKE_SYSTEM_NAME MATCHES "NetBSD")
    SET(libdiscid_OS "netbsd")
ELSEIF(CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
    SET(libdiscid_OS "netbsd")
ELSEIF(CMAKE_SYSTEM_NAME MATCHES "SunOS")
    SET(libdiscid_OS "solaris")
ELSEIF(CMAKE_SYSTEM_NAME MATCHES "Windows")
    SET(libdiscid_OS "win32")
ELSEIF(CMAKE_SYSTEM_NAME MATCHES "CYGWIN")
    SET(libdiscid_OS "win32")
ELSE()
    SET(libdiscid_OS "generic")
    MESSAGE(STATUS "WARNING: unknown operating system, no disc reading available!")
ENDIF()

# choose platform dependent source files
IF(libdiscid_OS MATCHES "win32")
    SET(libdiscid_OSDEP_SRCS src/toc.c src/disc_win32.c)
    SET(libdiscid_RCS ${CMAKE_CURRENT_BINARY_DIR}/versioninfo.rc)
ELSEIF(libdiscid_OS MATCHES "darwin")
    # TODO: TOC reading code for Darwin/OS X
    SET(libdiscid_OSDEP_SRCS src/toc.c src/unix.c src/disc_darwin.c)
    FIND_LIBRARY(COREFOUNDATION_LIBRARY CoreFoundation)
    SET(libdiscid_OSDEP_LIBS ${COREFOUNDATION_LIBRARY} IOKit)
ELSEIF(libdiscid_OS MATCHES "generic")
    SET(libdiscid_OSDEP_SRCS src/disc_${libdiscid_OS}.c)
ELSE()
    # unix platforms are the standard/default case
    SET(libdiscid_OSDEP_SRCS src/toc.c src/unix.c src/disc_${libdiscid_OS}.c)
ENDIF()

STRING(REPLACE ";" " " libdiscid_OSDEP_STR "${libdiscid_OSDEP_SRCS}")
MESSAGE(STATUS "Using discid implementation ${libdiscid_OSDEP_STR}")

ADD_LIBRARY(libdiscid SHARED ${libdiscid_OSDEP_SRCS} ${libdiscid_RCS} src/base64.c src/disc.c src/sha1.c)
TARGET_LINK_LIBRARIES(libdiscid ${libdiscid_OSDEP_LIBS})
SET_TARGET_PROPERTIES(libdiscid PROPERTIES
    OUTPUT_NAME discid
    VERSION ${libdiscid_VERSION}
    SOVERSION ${libdiscid_SOVERSION}
)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/include
        ${CMAKE_CURRENT_BINARY_DIR}/include)

ADD_EXECUTABLE(discid examples/discid.c)
TARGET_LINK_LIBRARIES(discid libdiscid)

ADD_EXECUTABLE(discisrc examples/discisrc.c)
TARGET_LINK_LIBRARIES(discisrc libdiscid)

ADD_EXECUTABLE(test_discid test/test_discid.c)
TARGET_LINK_LIBRARIES(test_discid libdiscid)

INSTALL(TARGETS libdiscid DESTINATION ${LIB_INSTALL_DIR})
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libdiscid.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/include/discid/discid.h DESTINATION ${INCLUDE_INSTALL_DIR}/discid)


ADD_CUSTOM_TARGET(docs doxygen)

ADD_CUSTOM_TARGET(check ./test_discid DEPENDS test_discid)

SET(libdiscid_DISTDIR "${PROJECT_NAME}-${PROJECT_VERSION}")

ADD_CUSTOM_TARGET(dist
   COMMAND git clone "${CMAKE_CURRENT_SOURCE_DIR}" "${libdiscid_DISTDIR}"
   COMMAND cd "${libdiscid_DISTDIR}" && ./autogen.sh
   COMMAND cd "${libdiscid_DISTDIR}" && ./configure && make distcheck
   COMMAND cp "${libdiscid_DISTDIR}/${libdiscid_DISTDIR}.tar.gz" .
   COMMAND rm -rf "${libdiscid_DISTDIR}"
)
ADD_DEPENDENCIES(dist check)

# create binary in MinGW/MSYS
IF(libdiscid_OS MATCHES "win32")
    ADD_CUSTOM_TARGET(distwin32
	COMMAND mkdir "${libdiscid_DISTDIR}-win32"
	COMMAND tar -xf "${libdiscid_DISTDIR}.tar.gz"
	COMMAND cp -a "${libdiscid_DISTDIR}" "${libdiscid_DISTDIR}-win32/"
	COMMAND rm -rf "${libdiscid_DISTDIR}"
	COMMAND cp "libdiscid.dll" "${libdiscid_DISTDIR}-win32/discid.dll"
	COMMAND zip -r "${libdiscid_DISTDIR}-win32.zip" "${libdiscid_DISTDIR}-win32/"
	COMMAND rm -rf "${libdiscid_DISTDIR}-win32"
    )
    ADD_DEPENDENCIES(distwin32 dist)
ENDIF()

# create universal binary on Mac OS X
IF(libdiscid_OS MATCHES "darwin")
    SET(darwin_build "${libdiscid_DISTDIR}/_build_darwin")
    ADD_CUSTOM_TARGET(distmac
        COMMAND mkdir "${libdiscid_DISTDIR}-mac"
        COMMAND tar -xf "${libdiscid_DISTDIR}.tar.gz"
        COMMAND cp -a "${libdiscid_DISTDIR}" "${libdiscid_DISTDIR}-mac/"
        COMMAND cd "${libdiscid_DISTDIR}-mac"
                && mkdir intel32 intel64 ppc universal
        COMMAND mkdir "${darwin_build}_32"
        COMMAND cd "${darwin_build}_32" && CMAKE_OSX_ARCHITECTURES=i386 cmake ..
        COMMAND cd "${darwin_build}_32" && make check
        COMMAND cp ${darwin_build}_32/libdiscid.${PROJECT_VERSION}.dylib
                "${libdiscid_DISTDIR}-mac/intel32/libdiscid.0.dylib"
        COMMAND mkdir "${darwin_build}_64"
        COMMAND cd "${darwin_build}_64"
                && CMAKE_OSX_ARCHITECTURES=x86_64 cmake ..
        COMMAND cd "${darwin_build}_64" && make check
        COMMAND cp ${darwin_build}_64/libdiscid.${PROJECT_VERSION}.dylib
                "${libdiscid_DISTDIR}-mac/intel64/libdiscid.0.dylib"
        COMMAND mkdir "${darwin_build}_ppc"
        COMMAND cd "${darwin_build}_ppc" && CMAKE_OSX_ARCHITECTURES=ppc cmake ..
        COMMAND cd "${darwin_build}_ppc" && make check
        COMMAND cp ${darwin_build}_ppc/libdiscid.${PROJECT_VERSION}.dylib
                "${libdiscid_DISTDIR}-mac/ppc/libdiscid.0.dylib"
        COMMAND lipo -create
                ${darwin_build}_*/libdiscid.${PROJECT_VERSION}.dylib
                -output "${libdiscid_DISTDIR}-mac/universal/libdiscid.0.dylib"
        COMMAND rm -rf "${darwin_build}_i386" "${darwin_build}_x86_64"
                "${darwin_build}_ppc"
        COMMAND rm -rf "${libdiscid_DISTDIR}"
        COMMAND zip -r "${libdiscid_DISTDIR}-mac.zip"
                "${libdiscid_DISTDIR}-mac/"
        COMMAND rm -rf "${libdiscid_DISTDIR}-mac"
    )
    ADD_DEPENDENCIES(distmac dist)
ENDIF()


# Tests needed for sha1.h
INCLUDE(TestBigEndian)
TEST_BIG_ENDIAN(WORDS_BIGENDIAN)
INCLUDE(CheckTypeSize)
CHECK_TYPE_SIZE(long SIZEOF_LONG)

CONFIGURE_FILE(config-cmake.h.in ${CMAKE_BINARY_DIR}/config.h)
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})
ADD_DEFINITIONS(-DHAVE_CONFIG_H)

IF(CMAKE_COMPILER_IS_GNUCC)
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -O2")
ENDIF()

## libdiscid 0.2.2

=== debian/changelog ===
libdiscid (0.2.2-3) unstable; urgency=low

  * QA upload.
  * Build with Multiarch support.

 -- Alessio Treglia <alessio@debian.org>  Tue, 14 Feb 2012 01:51:45 +0100

libdiscid (0.2.2-2) unstable; urgency=low

  * QA upload.
  * Get rid of unneeded *.la files (Closes: #621615).
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Fri, 03 Jun 2011 11:29:36 +0200

libdiscid (0.2.2-1) unstable; urgency=low

  * QA upload.
  * New upstream release. (Closes: #504115)
  * debian/control:
    - Use Homepage field instead of using the extended description for that.
    - Use ${source:Version} instead of deprecated ${binary:Version}.
    - Bump Standards-Version to 3.8.3.
    - Drop duplicate binary control field "section".
    - Fix duplicate short description.
  * Refer to versioned LGPL license.
  * Bump debhelper version to 7.
  * debian/rules: Fix order of includes.
  * Update debian/copyright.
  * Use new 3.0 (quilt) source format.
  * Add kfreebsd.patch for fix FTBFS on GNU/kFreeBSD (Closes: #546912).
  * Add hurd.patch to fix the FTBFS on GNU/Hurd (Closes: #558756).
  * Add symbols file to libdiscid0.

 -- Benjamin Drung <bdrung@ubuntu.com>  Sat, 05 Dec 2009 23:12:11 +0100

libdiscid (0.1.0-1) unstable; urgency=low

  * Initial release. (Closes: #390240)

 -- Lukáš Lalinský <lalinsky@gmail.com>  Sat, 30 Aug 2006 01:31:03 +0200

=== debian/control ===
Source: libdiscid
Section: libs
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 8.1.3~), cdbs (>= 0.4.93~)
Standards-Version: 3.9.2
Homepage: http://musicbrainz.org/doc/libdiscid

Package: libdiscid0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library for creating MusicBrainz DiscIDs
 libdiscid is a library for creating MusicBrainz DiscIDs from audio CDs.
 It reads a CD's table of contents (TOC) and generates an identifier which
 can be used to lookup the CD at MusicBrainz (http://musicbrainz.org).
 Additionally, it provides a submission URL for adding the DiscID to the
 database.

Package: libdiscid0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libdiscid0 (= ${binary:Version})
Description: Library for creating MusicBrainz DiscIDs (development files)
 libdiscid is a library for creating MusicBrainz DiscIDs from audio CDs.
 It reads a CD's table of contents (TOC) and generates an identifier which
 can be used to lookup the CD at MusicBrainz (http://musicbrainz.org).
 Additionally, it provides a submission URL for adding the DiscID to the
 database.
 .
 This is the development package which contains headers and libraries for
 libdiscid.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

DEB_CONFIGURE_EXTRA_FLAGS += --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)

## libdiscid 0.5.1

=== debian/changelog ===
libdiscid (0.5.1-1) unstable; urgency=low

  * New upstream release.
  * debian/rules: Enable verbose build output.
  * debian/copyright: Document src/ntddcdrm.h.

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 20 Jun 2013 18:23:28 +0200

libdiscid (0.5.0-2) unstable; urgency=low

  * Upload to unstable.

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 04 May 2013 22:31:50 +0200

libdiscid (0.5.0-1) experimental; urgency=low

  * New upstream release.
  * debian/libdiscid0.symbols:
    - Add new symbol discid_read_sparse.
    - Remove private symbols.
      These symbols are only used internally and are not used by any reverse
      dependency. They were exported unintentionally and were never listed in
      the header. Upstream now hides them properly.
    - Add Build-Depends-Package.
  * debian/rules: Enable parallel builds.
  * debian/copyright: Update Lukáš Lalinský's copyright years.

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 12 Apr 2013 18:22:09 +0200

libdiscid (0.4.1-1) experimental; urgency=low

  * New upstream release.
  * debian/patches/hurd.patch: Not needed anymore, superseded by upstream's
    generic platform support.

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 08 Mar 2013 19:10:48 +0100

libdiscid (0.4.0-1) experimental; urgency=low

  * New upstream release. (Closes: #702570)
  * debian/rules: Run docs target instead of running doxygen manually.
  * debian/libdiscid0.symbols: Add new symbols.
  * debian/patches/hurd.patch: Refresh.

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 08 Mar 2013 15:27:57 +0100

libdiscid (0.3.2-1) experimental; urgency=low

  * New upstream release. (Closes: #700366)
  * debian/copyright: Add Johannes Dewender.
  * debian/patches/hurd.path: Refresh.

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 12 Feb 2013 11:06:24 +0100

libdiscid (0.3.0-2) experimental; urgency=low

  * debian/control:
    - Add Vcs* fields.
    - Add libdiscid0-dbg package.
    - Add libdiscid-doc package.
    - Add doxygen to Build-Depends to build the documentation.
  * debian/rules:
    - Build the -dbg package.
    - Run doxygen and build the -doc package.
  * Install examples in the -doc package.

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 07 Feb 2013 15:43:04 +0100

libdiscid (0.3.0-1) experimental; urgency=low

  * New maintainer. (Closes: #555893)
  * New upstream release.
  * debian/rules:
    - Rewrite to use dh(1).
    - Use dh-autoreconf to update configure.
  * debian/control:
    - Remove cdbs from Build-Depends.
    - Remove ${shlibs:Depends} from libdiscid-dev's Depends.
    - Bump Standards-Version to 3.9.4, no changes required.
  * debian/patches:
    - autoreconf.patch: Removed, not needed anymore.
    - kfreebsd.patch: Removed, merged upstream.
    - hurd.patch: Refreshed.
  * debian/libdiscid0.symbols: Add new symbols.
  * debian/copyright:
    - Convert to Copyright Format 1.0.
    - Update copyright holders.
    - Add myself.

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 07 Feb 2013 01:00:41 +0100

=== debian/control ===
Source: libdiscid
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Sebastian Ramacher <sramacher@debian.org>
Build-Depends:
 debhelper (>= 9),
 dh-autoreconf
Build-Depends-Indep:
 doxygen
Standards-Version: 3.9.4
Homepage: http://musicbrainz.org/doc/libdiscid
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/libdiscid.git -b master
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/libdiscid.git

Package: libdiscid0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 libdiscid0-dbg (= ${binary:Version})
Description: library for creating MusicBrainz DiscIDs
 libdiscid is a library for creating MusicBrainz DiscIDs from audio CDs.
 It reads a CD's table of contents (TOC) and generates an identifier which
 can be used to lookup the CD at MusicBrainz (http://musicbrainz.org).
 Additionally, it provides a submission URL for adding the DiscID to the
 database.

Package: libdiscid0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libdiscid0 (= ${binary:Version})
Suggests:
 libdiscid-doc (= ${source:Version})
Description: library for creating MusicBrainz DiscIDs (development files)
 libdiscid is a library for creating MusicBrainz DiscIDs from audio CDs.
 It reads a CD's table of contents (TOC) and generates an identifier which
 can be used to lookup the CD at MusicBrainz (http://musicbrainz.org).
 Additionally, it provides a submission URL for adding the DiscID to the
 database.
 .
 This is the development package which contains headers and libraries for
 libdiscid.

Package: libdiscid0-dbg
Priority: extra
Section: debug
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libdiscid0 (= ${binary:Version})
Description: library for creating MusicBrainz DiscIDs (debugging symbols)
 libdiscid is a library for creating MusicBrainz DiscIDs from audio CDs.
 It reads a CD's table of contents (TOC) and generates an identifier which
 can be used to lookup the CD at MusicBrainz (http://musicbrainz.org).
 Additionally, it provides a submission URL for adding the DiscID to the
 database.
 .
 This package provides the debugging symbols for the shared library.

Package: libdiscid-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 libjs-jquery
Description: library for creating MusicBrainz DiscIDs (documentation)
 libdiscid is a library for creating MusicBrainz DiscIDs from audio CDs.
 It reads a CD's table of contents (TOC) and generates an identifier which
 can be used to lookup the CD at MusicBrainz (http://musicbrainz.org).
 Additionally, it provides a submission URL for adding the DiscID to the
 database.
 .
 This package constains the documentation for libdiscid.

=== debian/rules ===
#!/usr/bin/make -f

# enable verbose build output
export V=1

%:
	dh $@ --parallel --with autoreconf

# build documentation if doxygen is available and remove the copy of jquery and
# replace it with the one from libjs-jquery
override_dh_auto_build-indep:
ifneq "$(wildcard /usr/bin/doxygen)" ""
	$(MAKE) docs
	rm -f docs/installdox
	rm docs/jquery.js
	ln -s /usr/share/javascript/jquery/jquery.js docs/jquery.js
endif

# no tests and install for indep
override_dh_auto_test-indep override_dh_auto_install-indep:

override_dh_strip:
	dh_strip -plibdiscid0 --dbg-package=libdiscid0-dbg

## libdiscid 0.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 # MINOR is increased when features are added to the API
 # PATCH is increase for all other releases
 SET(libdiscid_MAJOR 0)
-SET(libdiscid_MINOR 5)
+SET(libdiscid_MINOR 6)
 SET(libdiscid_PATCH 1)
 
 
@@ -76,7 +76,6 @@
     SET(libdiscid_OSDEP_SRCS src/toc.c src/disc_win32.c)
     SET(libdiscid_RCS ${CMAKE_CURRENT_BINARY_DIR}/versioninfo.rc)
 ELSEIF(libdiscid_OS MATCHES "darwin")
-    # TODO: TOC reading code for Darwin/OS X
     SET(libdiscid_OSDEP_SRCS src/toc.c src/unix.c src/disc_darwin.c)
     FIND_LIBRARY(COREFOUNDATION_LIBRARY CoreFoundation)
     SET(libdiscid_OSDEP_LIBS ${COREFOUNDATION_LIBRARY} IOKit)
@@ -90,6 +89,13 @@
 STRING(REPLACE ";" " " libdiscid_OSDEP_STR "${libdiscid_OSDEP_SRCS}")
 MESSAGE(STATUS "Using discid implementation ${libdiscid_OSDEP_STR}")
 
+# This is only a dependency for a libmusicbrainz example
+SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
+FIND_PACKAGE(Musicbrainz5 QUIET)
+IF(NOT MUSICBRAINZ5_FOUND)
+    SET(MUSICBRAINZ5_INCLUDE_DIRS "")
+ENDIF()
+
 ADD_LIBRARY(libdiscid SHARED ${libdiscid_OSDEP_SRCS} ${libdiscid_RCS} src/base64.c src/disc.c src/sha1.c)
 TARGET_LINK_LIBRARIES(libdiscid ${libdiscid_OSDEP_LIBS})
 SET_TARGET_PROPERTIES(libdiscid PROPERTIES
@@ -98,16 +104,26 @@
     SOVERSION ${libdiscid_SOVERSION}
 )
 INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/include
-        ${CMAKE_CURRENT_BINARY_DIR}/include)
+	${CMAKE_CURRENT_BINARY_DIR}/include ${MUSICBRAINZ5_INCLUDE_DIRS})
 
 ADD_EXECUTABLE(discid examples/discid.c)
 TARGET_LINK_LIBRARIES(discid libdiscid)
-
 ADD_EXECUTABLE(discisrc examples/discisrc.c)
 TARGET_LINK_LIBRARIES(discisrc libdiscid)
-
-ADD_EXECUTABLE(test_discid test/test_discid.c)
-TARGET_LINK_LIBRARIES(test_discid libdiscid)
+IF(MUSICBRAINZ5_FOUND)
+    ADD_EXECUTABLE(disc_metadata examples/disc_metadata.c)
+    TARGET_LINK_LIBRARIES(disc_metadata libdiscid
+                          ${MUSICBRAINZ5_LIBRARIES} stdc++)
+ENDIF()
+
+ADD_EXECUTABLE(test_core EXCLUDE_FROM_ALL test/test.c test/test_core.c)
+TARGET_LINK_LIBRARIES(test_core libdiscid)
+ADD_EXECUTABLE(test_put EXCLUDE_FROM_ALL test/test.c test/test_put.c)
+TARGET_LINK_LIBRARIES(test_put libdiscid)
+ADD_EXECUTABLE(test_read EXCLUDE_FROM_ALL test/test.c test/test_read.c)
+TARGET_LINK_LIBRARIES(test_read libdiscid)
+ADD_EXECUTABLE(test_read_full EXCLUDE_FROM_ALL test/test.c test/test_read_full.c)
+TARGET_LINK_LIBRARIES(test_read_full libdiscid)
 
 INSTALL(TARGETS libdiscid DESTINATION ${LIB_INSTALL_DIR})
 INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libdiscid.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
@@ -116,7 +132,38 @@
 
 ADD_CUSTOM_TARGET(docs doxygen)
 
-ADD_CUSTOM_TARGET(check ./test_discid DEPENDS test_discid)
+ADD_CUSTOM_TARGET(check
+	COMMAND echo test_core:
+	COMMAND echo ----------
+	COMMAND ./test_core
+	COMMAND echo && echo
+	COMMAND echo test_put:
+	COMMAND echo ---------
+	COMMAND ./test_put
+	COMMAND echo && echo
+	COMMAND echo test_read:
+	COMMAND echo ----------
+	COMMAND ./test_read || test $$? -eq 77
+	COMMAND echo && echo
+	COMMAND echo test_read_full:
+	COMMAND echo ---------------
+	COMMAND ./test_read_full || test $$? -eq 77
+	DEPENDS test_core test_put test_read test_read_full)
+
+ADD_CUSTOM_TARGET(memcheck
+	COMMAND valgrind --quiet --error-exitcode=1 --leak-check=full
+		./test_core > /dev/null
+	COMMAND valgrind --quiet --error-exitcode=1 --leak-check=full
+		./test_put > /dev/null
+	COMMAND valgrind --quiet --error-exitcode=1 --leak-check=full
+		./test_read > /dev/null || test $$? -eq 77
+	COMMAND valgrind --quiet --error-exitcode=1 --leak-check=full
+		./test_read_full > /dev/null || test $$? -eq 77
+	COMMAND valgrind --quiet --error-exitcode=66 --leak-check=full
+		./discid > /dev/null || test $$? -ne 66
+	COMMAND valgrind --quiet --error-exitcode=66 --leak-check=full
+		./discisrc > /dev/null || test $$? -ne 66
+	DEPENDS test_core test_put test_read test_read_full)
 
 SET(libdiscid_DISTDIR "${PROJECT_NAME}-${PROJECT_VERSION}")

=== debian/changelog ===
libdiscid (0.6.1-6) unstable; urgency=medium

  * debian/{control,compat,rules}: Bump debhelper compat to 10.
  * debian/control:
    - Bump Standards-Version to 3.9.8.
    - Update Vcs-Git.

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 16 Nov 2016 20:44:51 +0100

libdiscid (0.6.1-5) unstable; urgency=medium

  * Move to automatic debug packages.
    - debian/control:
      + Bump debhelper B-D to 9.20151219.
      + Remove libdiscid0-dbg package.
    - debian/rules: Call dh_strip with --ddeb-migration.
  * debian/control: Update Vcs-Git.
  * debian/rules: Update dh_auto_clean override.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 20 Dec 2015 21:04:17 +0100

libdiscid (0.6.1-4) unstable; urgency=medium

  * debian/control:
    - Remove transitional libdiscid0-dev package.
    - Bump Standards-Version to 3.9.6.
    - Remove obsolete Breaks and Replaces from libdiscid-dev.
    - Add graphviz to Build-Depends-Indep.
  * debian/copyright:
    - Update copyright years.
    - Fix path for src/ntddcdrm.h.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 03 May 2015 14:54:30 +0200

libdiscid (0.6.1-3) unstable; urgency=medium

  * Remove SOVERSION from -dev package.
    - debian/control: Rename libdiscid0-dev to libdiscid-dev and provide
      transitional libdiscid0-dev package.
    - Renamed debian/libdiscid0-dev.install to debian/libdiscid-dev.install.
  * debian/rules: Make the package build twice in a row.
  * debian/control: Bump Standards-Version to 3.9.5.

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 01 Jul 2014 18:52:37 +0200

libdiscid (0.6.1-2) unstable; urgency=low

  * debian/patches/generic-dev-null.patch: Don't return an empty string for
    the default device in the generic backend. Fixes build failure on
    hurd-i386.

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 04 Oct 2013 01:13:08 +0200

libdiscid (0.6.1-1) unstable; urgency=low

  * New upstream release.
  * debian/libdiscid0.symbols: Add new symbol discid_get_toc_string.

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 03 Oct 2013 20:26:53 +0200

libdiscid (0.5.2-1) unstable; urgency=low

  * New upstream release.
  * debian/libdiscid-doc.docs: Ship README and AUTHORS in the -doc package.
  * debian/control: Drop version from Suggests in libdiscid0-dev.
  * debian/rules: Ensure that libdiscid is built with -DNDEBUG

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 01 Aug 2013 23:51:28 +0200

=== debian/control ===
Source: libdiscid
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Sebastian Ramacher <sramacher@debian.org>
Build-Depends:
 debhelper (>= 10)
Build-Depends-Indep:
 doxygen,
 graphviz
Standards-Version: 3.9.8
Homepage: http://musicbrainz.org/doc/libdiscid
Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/libdiscid.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/libdiscid.git

Package: libdiscid0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: library for creating MusicBrainz DiscIDs
 libdiscid is a library for creating MusicBrainz DiscIDs from audio CDs.
 It reads a CD's table of contents (TOC) and generates an identifier which
 can be used to lookup the CD at MusicBrainz (http://musicbrainz.org).
 Additionally, it provides a submission URL for adding the DiscID to the
 database.

Package: libdiscid-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libdiscid0 (= ${binary:Version})
Suggests:
 libdiscid-doc
Description: library for creating MusicBrainz DiscIDs (development files)
 libdiscid is a library for creating MusicBrainz DiscIDs from audio CDs.
 It reads a CD's table of contents (TOC) and generates an identifier which
 can be used to lookup the CD at MusicBrainz (http://musicbrainz.org).
 Additionally, it provides a submission URL for adding the DiscID to the
 database.
 .
 This is the development package which contains headers and libraries for
 libdiscid.

Package: libdiscid-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 libjs-jquery
Description: library for creating MusicBrainz DiscIDs (documentation)
 libdiscid is a library for creating MusicBrainz DiscIDs from audio CDs.
 It reads a CD's table of contents (TOC) and generates an identifier which
 can be used to lookup the CD at MusicBrainz (http://musicbrainz.org).
 Additionally, it provides a submission URL for adding the DiscID to the
 database.
 .
 This package constains the documentation for libdiscid.

=== debian/rules ===
#!/usr/bin/make -f

# always build with -DNDEDUG to get rid of the asserts
export DEB_CPPFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@

override_dh_auto_clean-indep:
	rm -rf docs

# build documentation if doxygen is available and remove the copy of jquery and
# replace it with the one from libjs-jquery
override_dh_auto_build-indep:
ifneq "$(wildcard /usr/bin/doxygen)" ""
	$(MAKE) docs
	rm -f docs/installdox
	rm docs/jquery.js
	ln -s /usr/share/javascript/jquery/jquery.js docs/jquery.js
endif

# no tests and install for indep
override_dh_auto_test-indep override_dh_auto_install-indep:

# The following override can be removed after stretch has been released.
override_dh_strip:
	dh_strip --ddeb-migration='libdiscid0-dbg (<< 0.6.1-5~)'

## libdiscid 0.6.2

=== debian/changelog ===
libdiscid (0.6.2-3) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Change Format URL to correct one
  * d/control: Set Vcs-* to salsa.debian.org

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ Sebastian Ramacher ]
  * debian/control:
    - Bump Standards-Version.
  * debian/:
    - Use https upstream URLs.
    - Bump debhelper compat level to 11.

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 22 May 2018 15:54:35 +0200

libdiscid (0.6.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 16 Jun 2017 00:59:02 +0200

libdiscid (0.6.2-1) experimental; urgency=medium

  * New upstream release.
  * debian/patches: Removed, included upstream.
  * debian/{control,rules,libdiscid-doc.lintian-overrides}: doxygen's
    jquers.js is not the same as jquery.
  * debian/rules: Drop obsolete override.
  * debian/copyright: Update copyright years.

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 30 Jan 2017 20:48:22 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,17 @@
 Source: libdiscid
 Section: libs
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: Sebastian Ramacher <sramacher@debian.org>
 Build-Depends:
- debhelper (>= 10)
+ debhelper (>= 11)
 Build-Depends-Indep:
  doxygen,
  graphviz
-Standards-Version: 3.9.8
-Homepage: http://musicbrainz.org/doc/libdiscid
-Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/libdiscid.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/libdiscid.git
+Standards-Version: 4.1.4
+Homepage: https://musicbrainz.org/doc/libdiscid
+Vcs-Git: https://salsa.debian.org/multimedia-team/libdiscid.git
+Vcs-Browser: https://salsa.debian.org/multimedia-team/libdiscid
 
 Package: libdiscid0
 Architecture: any
@@ -50,8 +50,7 @@
 Architecture: all
 Multi-Arch: foreign
 Depends:
- ${misc:Depends},
- libjs-jquery
+ ${misc:Depends}
 Description: library for creating MusicBrainz DiscIDs (documentation)
  libdiscid is a library for creating MusicBrainz DiscIDs from audio CDs.
  It reads a CD's table of contents (TOC) and generates an identifier which

=== debian/watch ===
version=3
https://musicbrainz.org/doc/libdiscid .*/libdiscid-(.*)\.tar\.gz

## libdiscid 0.6.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.12)
 set(CMAKE_LEGACY_CYGWIN_WIN32 0)
 
 PROJECT(libdiscid C)
@@ -11,7 +11,7 @@
 # PATCH is increase for all other releases
 SET(libdiscid_MAJOR 0)
 SET(libdiscid_MINOR 6)
-SET(libdiscid_PATCH 1)
+SET(libdiscid_PATCH 4)
 
 
 SET(libdiscid_VERSION ${libdiscid_MAJOR}.${libdiscid_MINOR}.${libdiscid_PATCH})
@@ -29,20 +29,15 @@
 SET(PROJECT_VERSION ${libdiscid_VERSION})
 
 
-SET(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
-SET(EXEC_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX} CACHE PATH "Installation prefix for executables and object code libraries" FORCE)
-SET(BIN_INSTALL_DIR ${EXEC_INSTALL_PREFIX}/bin CACHE PATH "Installation prefix for user executables" FORCE)
-SET(LIB_INSTALL_DIR ${EXEC_INSTALL_PREFIX}/lib${LIB_SUFFIX} CACHE PATH  "Installation prefix for object code libraries" FORCE)
-SET(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include CACHE PATH "Installation prefix for C header files" FORCE)
+INCLUDE(GNUInstallDirs)
+SET(BIN_INSTALL_DIR ${CMAKE_INSTALL_FULL_BINDIR} CACHE PATH "Installation prefix for user executables" FORCE)
+SET(LIB_INSTALL_DIR ${CMAKE_INSTALL_FULL_LIBDIR} CACHE PATH  "Installation prefix for object code libraries" FORCE)
+SET(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR} CACHE PATH "Installation prefix for C header files" FORCE)
 
 # compatibility with automake
 SET(PACKAGE ${PROJECT_NAME})
 SET(VERSION ${PROJECT_VERSION})
 SET(PACKAGE_STRING "${PACKAGE} ${VERSION}")
-SET(prefix ${CMAKE_INSTALL_PREFIX})
-SET(exec_prefix ${EXEC_INSTALL_PREFIX})
-SET(includedir ${INCLUDE_INSTALL_DIR})
-SET(libdir ${LIB_INSTALL_DIR})
 
 CONFIGURE_FILE(libdiscid.pc.in libdiscid.pc)
 CONFIGURE_FILE(versioninfo.rc.in versioninfo.rc)
@@ -55,13 +50,17 @@
 ELSEIF(CMAKE_SYSTEM_NAME MATCHES "Darwin")
     SET(libdiscid_OS "darwin")
 ELSEIF(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
-    SET(libdiscid_OS "freebsd")
+    SET(libdiscid_OS "bsd")
 ELSEIF(CMAKE_SYSTEM_NAME MATCHES "NetBSD")
-    SET(libdiscid_OS "netbsd")
+    SET(libdiscid_OS "bsd")
+    SET(libdiscid_OSDEP_LIBS util) # for getrawpartition
 ELSEIF(CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
-    SET(libdiscid_OS "netbsd")
+    SET(libdiscid_OS "bsd")
+    SET(libdiscid_OSDEP_LIBS util) # for getrawpartition
 ELSEIF(CMAKE_SYSTEM_NAME MATCHES "SunOS")
     SET(libdiscid_OS "solaris")
+ELSEIF(CMAKE_SYSTEM_NAME MATCHES "Haiku")
+    SET(libdiscid_OS "haiku")
 ELSEIF(CMAKE_SYSTEM_NAME MATCHES "Windows")
     SET(libdiscid_OS "win32")
 ELSEIF(CMAKE_SYSTEM_NAME MATCHES "CYGWIN")
@@ -72,18 +71,19 @@
 ENDIF()
 
 # choose platform dependent source files
-IF(libdiscid_OS MATCHES "win32")
+IF(libdiscid_OS STREQUAL "win32")
     SET(libdiscid_OSDEP_SRCS src/toc.c src/disc_win32.c)
     SET(libdiscid_RCS ${CMAKE_CURRENT_BINARY_DIR}/versioninfo.rc)
-ELSEIF(libdiscid_OS MATCHES "darwin")
-    SET(libdiscid_OSDEP_SRCS src/toc.c src/unix.c src/disc_darwin.c)
-    FIND_LIBRARY(COREFOUNDATION_LIBRARY CoreFoundation)
-    SET(libdiscid_OSDEP_LIBS ${COREFOUNDATION_LIBRARY} IOKit)
-ELSEIF(libdiscid_OS MATCHES "generic")
+ELSEIF(libdiscid_OS STREQUAL "generic")
     SET(libdiscid_OSDEP_SRCS src/disc_${libdiscid_OS}.c)
 ELSE()
     # unix platforms are the standard/default case
     SET(libdiscid_OSDEP_SRCS src/toc.c src/unix.c src/disc_${libdiscid_OS}.c)
+    IF(libdiscid_OS STREQUAL "darwin") # Extra libraries needed
+        FIND_LIBRARY(COREFOUNDATION_LIBRARY CoreFoundation)
+        FIND_LIBRARY(IOKIT_LIBRARY IOKit)
+        SET(libdiscid_OSDEP_LIBS ${COREFOUNDATION_LIBRARY} ${IOKIT_LIBRARY})
+    ENDIF()
 ENDIF()
 
 STRING(REPLACE ";" " " libdiscid_OSDEP_STR "${libdiscid_OSDEP_SRCS}")

=== debian/changelog ===
libdiscid (0.6.4-2build1) noble; urgency=high

  * No change rebuild for frame pointers (and time_t).

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 18 Apr 2024 19:55:20 +0200

libdiscid (0.6.4-2) unstable; urgency=medium

  * Upload to unstable

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 10 Jun 2023 13:54:36 +0200

libdiscid (0.6.4-1) experimental; urgency=medium

  [ Debian Janitor ]
  * Fix day-of-week for changelog entry 0.1.0-1.

  [ Diederik de Haas ]
  * Add Salsa's default CI pipeline
  * d/control: Bump debhelper compat level to 13
    - Add usr/lib/*/libdiscid.la to d/not-installed
  * d/control: Set `Rules-Requires-Root: no`
  * d/upstream/metadata: Set Bug-Database field

  [ Sebastian Ramacher ]
  * New upstream version 0.6.4
  * debian/control: Bump Standards-Version

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 02 Apr 2023 22:28:51 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,16 @@
 Source: libdiscid
 Section: libs
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: Sebastian Ramacher <sramacher@debian.org>
 Build-Depends:
- debhelper (>= 11)
+ debhelper-compat (= 13)
 Build-Depends-Indep:
  doxygen,
  graphviz
-Standards-Version: 4.1.4
+Rules-Requires-Root: no
+Standards-Version: 4.6.2
 Homepage: https://musicbrainz.org/doc/libdiscid
 Vcs-Git: https://salsa.debian.org/multimedia-team/libdiscid.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/libdiscid

=== debian/rules ===
#!/usr/bin/make -f

# always build with -DNDEDUG to get rid of the asserts
export DEB_CPPFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@

override_dh_auto_clean-indep:
	rm -rf docs

override_dh_auto_build-indep:
	$(MAKE) docs
	rm -f docs/installdox
	find docs -name *.md5 -delete

# no tests and install for indep
override_dh_auto_test-indep override_dh_auto_install-indep:

## libdiscid 0.6.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 2.8.12...3.28.3)
 set(CMAKE_LEGACY_CYGWIN_WIN32 0)
 
 PROJECT(libdiscid C)
@@ -11,7 +11,7 @@
 # PATCH is increase for all other releases
 SET(libdiscid_MAJOR 0)
 SET(libdiscid_MINOR 6)
-SET(libdiscid_PATCH 4)
+SET(libdiscid_PATCH 5)
 
 
 SET(libdiscid_VERSION ${libdiscid_MAJOR}.${libdiscid_MINOR}.${libdiscid_PATCH})
@@ -38,6 +38,8 @@
 SET(PACKAGE ${PROJECT_NAME})
 SET(VERSION ${PROJECT_VERSION})
 SET(PACKAGE_STRING "${PACKAGE} ${VERSION}")
+SET(includedir ${INCLUDE_INSTALL_DIR})
+SET(libdir ${LIB_INSTALL_DIR})
 
 CONFIGURE_FILE(libdiscid.pc.in libdiscid.pc)
 CONFIGURE_FILE(versioninfo.rc.in versioninfo.rc)

=== debian/changelog ===
libdiscid (0.6.5-2) unstable; urgency=medium

  * Upload to unstable

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 06 Aug 2025 12:34:52 +0200

libdiscid (0.6.5-1) experimental; urgency=medium

  * New upstream version 0.6.5
  * debian/control: Bump Standards-Version

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 23 May 2025 18:46:26 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libdiscid
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: Sebastian Ramacher <sramacher@debian.org>
 Build-Depends:
  debhelper-compat (= 13)
@@ -10,7 +9,7 @@
  doxygen,
  graphviz
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://musicbrainz.org/doc/libdiscid
 Vcs-Git: https://salsa.debian.org/multimedia-team/libdiscid.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/libdiscid

=== debian/watch ===
version=4
https://musicbrainz.org/doc/libdiscid .*/libdiscid-(.*)\.tar\.gz
